function [c,s] = givens(x)
% following instructions from Matrix Computations, Golub & Van Loan
% m does not necessarily equal the m from the main algorithm!

a = x(1);
b = x(2);

if b == 0
    c = 1;
    s = 0;
    
else
    if abs(b) > abs(a)
        r = -a/b;
        s = 1/sqrt(1+r^2);
        c = s*r;
    else
        r = -b/a;
        c = 1/sqrt(1+r^2);
        s = c*r;
        
    end
end


end