function Gs = givens_special(x, i, j, dir)

if nargin < 4
    dir = 'left';
end

[c,s] = givens(x);

switch(dir)
    case 'left'
        Gs = @(A) apply_givens_special_left(A, c, s, i, j);
        
    case 'right'
        Gs = @(A) apply_givens_special_right(A, c, s, i, j);
        
    otherwise
        error('Unknown direction in the parameter dir!');
end

end

function A = apply_givens_special_left(A, c, s, i, j)

A([i,j], :) = [c, -s; s, c] * A([i,j], :);

end

function A = apply_givens_special_right(A, c, s, i, j)

A(:, [i,j]) = A(:, [i,j]) * [c, s; -s, c];

end

