function [beta, v] = house(x)
% following instructions from Matrix Computations, Golub & Van Loan

n = length(x);

sigma = norm(x(2:n))^2;

v = [1; reshape(x(2:n), [], 1)];

if sigma == 0
    beta = 0;
else
    norm_x = sqrt(x(1)^2 + sigma);
    
    if x(1) <= 0
        v(1) = x(1) - norm_x;
    else
        v(1) = -sigma / (x(1) + norm_x);
    end
    
    beta = 2*v(1)^2 / (sigma + v(1)^2);
    v = v / v(1);
end

end