function Gs = sympl_givens_3(x, i, j, m)

if i > m || j > m
    error('i or j is out of bounds!');
end

[c,s] = givens(x);

Gs = @(A) apply_sympl_givens(A, c, s, i, j, m);

end

function A = apply_sympl_givens(A, c, s, i, j, m)

A(:, [i,m+j]) = A(:, [i,m+j]) * [c, -s;  s, c];
A(:, [m+i,j]) = A(:, [m+i,j]) * [c,  s; -s, c];

end

