function Hs = sympl_house(x, i, m)

if i > m
    error('i is out of bounds!');
end

n = length(x);

[beta, v] = house(x);

Hs = @(A) apply_sympl_house(A, i:i+n-1, m, beta, v);

end

function A = apply_sympl_house(A, idx, m, beta, v)

idx = reshape(idx, 1, []);
A(:, idx) = A(:, idx) - beta * (A(:, idx) * v) *  v';
A(:, m+idx) = A(:, m+idx) - beta * (A(:, m+idx) * v) *  v';

end
