function Ps = sympl_move(i, j, m)
% ()*Ps moves columns: i to j and m+i to m+j

if i > m || j > m
    error('i or j is out of bounds!');
end

% generate permutation which moves i to j
p = move(i, j, m);

Ps = @(A) apply_sympl_move(A, p, m);

end

function A = apply_sympl_move(A, p, m)

p = reshape(p, 1, []);
A = A(:, [p, m+p]);

end
