function rb_sim_data = dyn_lin_elast_rb_reconstruction(model, detailed_data, rb_sim_data)
%function rb_sim_data = dyn_lin_elast_rb_reconstruction(model, detailed_data, rb_sim_data)
% Reconstructs full state from reduced simulation data
%   Truncated dirichlet values are NOT added
%
% Patrick Buchfink, July 2017

% initialization
start_reconstruction = tic;

% full state solution variable (for free dofs)
dofs = detailed_data.RB * rb_sim_data.reduced_dofs;

% Save full sized solution (free + Dirichlet)
uh = Fem.DiscFunc(dofs, detailed_data.truncated_df_info);

% return results:
rb_sim_data.uh = uh;
rb_sim_data.reconstruction_time = toc(start_reconstruction);
end